(*
         Ŀ
                     This is the source for program Gamma            
          The numerical computation are done using the unit SpecialF 
                                                                     
                                                   
                                   GAMMA.PAS                         
                                 19 April 1999                       
                                                   
                                                                     
           If you modify this program, please                        
                                                                     
              (1) Make sure that you have a copy of the original     
                  file.                                              
                                                                     
              (2) Delete this comment (23 lines).                    
                                                                     
           Original size of file:  7558 bytes.                       
         
             Copyright       Bent Nielsen
                             Nuffield College, Oxford OX1 1NF, UK
                             http://www.nuff.ox.ac.uk/users/nielsen
*)

PROGRAM GAMMA;
USES    Crt,SpecialF;
VAR     xval,mean,variance: Double;
        ch: Char;
        OK: Boolean;

PROCEDURE SetWindow(x,y,width,height,color: Byte);
BEGIN { PROCEDURE SetWindow }
  Window(x,y,x+width-1,y+height-1); TextBackground(color);
END;  { PROCEDURE SetWindow }

  PROCEDURE ReadReal(var r:Double; StringLength: Byte);
    VAR     s        : String;
            code     : Integer;
    PROCEDURE ReadString(var s:String; StringLength:Byte);
      CONST
            NULL     = #0;
            BSKEY    = #8;
            ENTER    = #13;
            SKIP     = #173;       { Alt X implies Halt }
            HOMEKEY  = #199;
            LEFTKEY  = #203;
            RIGHTKEY = #205;
            ENDKEY   = #207;
            DELKEY   = #211;
      VAR
            Ch       : Char;
            x        : Byte;
            decpoint : Byte;
      FUNCTION GetKey: Char;
        { Reads the next keyboard character - This unit enables the program
          to read function keys which have ASCII code > 127 }
      VAR      Ch : Char;
      BEGIN { FUNCTION GetKey }
        Ch:= NULL;
        Ch:= ReadKey;
        Repeat
          If Ch = NULL Then
            Begin
              Ch:= ReadKey;
              If Ord(Ch) > 127 Then
                Ch:= NULL
              Else
                Ch:= Chr(Ord(Ch) + 128);
            End;
        Until Ch <> NULL;
        If Ch= SKIP Then HALT;
        GetKey:= Ch;
      END;  { FUNCTION GetKey }
      PROCEDURE AddCharacter;
      BEGIN { PROCEDURE AddCharacter }
        If ( Length(s) < x ) AND ( Length(s)<StringLength )
        Then s:=s+ch Else s[x]:=ch;
        Inc(x);
        If x>StringLength Then x:=x-1;
      END;  { PROCEDURE AddCharacter }
      BEGIN { PROCEDURE ReadString }
        s:=''; x:=1; decpoint:=0;
        Repeat
          ch:=Getkey;
          Case ch Of
            '1','2','3','4','5','6','7','8','9','0'
                    : AddCharacter;
            '.'     : If decpoint=0 Then Begin decpoint:= x; Addcharacter End;
            BSKEY   : If x>1 Then Begin x:=x-1; Delete(s,x,1); End;
            HOMEKEY : x:=1;
            LEFTKEY : If x>1 Then x:=x-1;
            RIGHTKEY: If x < Length(s) Then x:=x+1;
            DELKEY  : If x <= Length(s) Then Delete(s,x,1);
            ENDKEY  : If x < StringLength Then x:= Length(s) + 1;
          END;
          ClrScr; GotoXY(1,1); Write(s); GotoXY(x,1);
        Until Ch=ENTER;
      END;  { PROCEDURE ReadString }
    BEGIN { PROCEDURE ReadReal }
      ReadString(s,StringLength);
      val(s,r,code);
    END;  { PROCEDURE ReadReal }

BEGIN { Gamma }
{ -------  Initial Comment --------- }
  SetWindow(1,1,80,25,Black); ClrScr;
  SetWindow(2,2,78,13,Blue); ClrScr;
  SetWindow(3,3,76,12,Blue);
    Writeln('GAMMA');
    Writeln;
    Writeln('This program computes quantiles and p-values for a Gamma distribution using');
    Writeln('numerical methods.  For documentation of the numerical procedure see the');
    Writeln('source code which is made using Borlands TurboPascal.');
    Writeln('INPUT  1: MEAN and VARIANCE of Gamma distribution');
    Writeln('OUTPUT 1: QUANTILES: 50%  80%  90%  95%  97.5%  99%');
    Writeln('INPUT  2: X-VALUE of own choice. Program computes p-value');
    Writeln;
    Writeln('Bent Nielsen, 19 April 1999');
    Writeln('http://www.nuff.ox.ac.uk/users/nielsen');
{ -------  Input 1 --------- }
  SetWindow(1,1,80,25,Black);
    GoToXY(2,16);Writeln('INPUT 1:');
    GoToXY(12,16);Writeln('mean:');
    GoToXY(12,17);Writeln('variance:');
  Repeat
    SetWindow(22,16,10,1,Red); ClrScr; SetWindow(23,16,9,1,Red);
      ReadReal(mean,8);
      If Mean<Precision
      Then Begin OK:= False; SetWindow(42,16,31,1,RED); ClrScr;
                 Write(' Restriction: Mean >',Precision:8); End
      Else Begin OK:= True; SetWindow(42,16,31,1,BLACK); ClrScr; End;
  Until OK;
  SetWindow(22,16,12,1,Black); ClrScr; GoToXY(2,1); TextColor(Green);
    Write(Mean:10:2); TextColor(White);
  Repeat
    SetWindow(22,17,10,1,Red); ClrScr; SetWindow(23,17,9,1,Red);
      ReadReal(variance,8);
      If Variance<Precision
      Then Begin OK:= False; SetWindow(42,17,30,1,RED); ClrScr;
                 Write(' Restriction: Var >',Precision:8); End
      Else Begin OK:= True; SetWindow(42,17,30,1,BLACK); ClrScr; End;
  Until OK;
  SetWindow(22,17,12,1,Black); ClrScr; GotoXY(2,1); TextColor(Green);
    Write(variance:10:2); TextColor(White);
{ -------  Output 1 --------- }
  SetWindow(1,1,80,25,Black);
    TextColor(GREEN); GoToXY(35,16); Write('= scale * shape');
                      GoToXY(35,17); Write('= scale * shape^2');
    TextColor(WHITE);
    GotoXY(2,19);Write('OUTPUT 2:');
    GotoXY(12,19);Write('shape =',Sqr(mean)/variance:10:4);
                  Write('    scale =',variance/mean:10:4);
    GotoXY(12,20);Write('quantiles:');
    GotoXY(24,20);Write('    50%      80%      90%      95%      97.5%    99%');
    GotoXY(24,21);Write(QuantileGamma(mean,variance,0.5,3):9:3);
                  Write(QuantileGamma(mean,variance,0.8,3):9:3);
                  Write(QuantileGamma(mean,variance,0.9,3):9:3);
                  Write(QuantileGamma(mean,variance,0.95,3):9:3);
                  Write(QuantileGamma(mean,variance,0.975,3):9:3);
                  Write(QuantileGamma(mean,variance,0.99,3):9:3);
{ -------  Input 2 --------- }
    GotoXY(2,23);Write('INPUT 2:');
    GoToXY(12,23);Writeln('x-value:');
  SetWindow(22,23,10,1,Red); ClrScr; SetWindow(23,23,9,1,Red);
    ReadReal(xval,8);
  SetWindow(22,23,12,1,Black); ClrScr; GoToXY(2,1); TextColor(Green);
    Write(xval:10:2); TextColor(White);
{ -------  Output 2 --------- }
  SetWindow(1,1,80,25,Black); GotoXY(35,23);
    Write('=>  p-value = ',100*(1-DistGamma(mean,variance,xval,3)):6:2,' % ');
{ -------  End of interface --------- }
  SetWindow(50,25,26,1,RED);clrscr;
    Write(' Quit by pressing any key');
    Ch:=ReadKey;
END.  { Gamma }